<template>
    <section class="section section-events section--white section-events--white" tabindex="-1" style="outline: none;">
        <div class="container">
            <div class="events__header">
                <p class="events__header-text">Выберите то, что вас интересует:</p>
                <ul class="events__header-filters">
                    <li class="events__filters-type">
                        <label>
                            <input class="visually-hidden" type="radio" name="event-type" v-model="eventType" value="null" checked>
                            <span class="event__switch-imitate">Все события</span>
                        </label>
                        <label>
                            <input class="visually-hidden" type="radio" name="event-type" v-model="eventType" value="online">
                            <span class="event__switch-imitate">Онлайн</span>
                        </label>
                        <label>
                            <input class="visually-hidden" type="radio" name="event-type" v-model="eventType" value="offline">
                            <span class="event__switch-imitate">Очно</span>
                        </label>
                    </li>
                    <li class="events__filters-city select--arrow" v-if="eventType == 'offline'">
                        <select name="event-city" v-model="selectCity">
                            <option value="null" selected>Все города</option>
                            <option v-for="(city, index) in cities" :key="index" :value="city">{{ city }}</option>
                        </select>
                    </li>
                </ul>
            </div>
            <div class="events__content">
                <card-event 
                v-for="(item, index) in itemsVisible" 
                :key="index" 
                :index="index" 
                :item="item"  
                v-show="(index + 1) > ((pagination.currentPage - 1) * pagination.perPage) && (index + 1) <= (pagination.currentPage * pagination.perPage)"
                ></card-event>
            </div>
            <div class="events__footer pagination">
                <div class="pagination__items" v-if="(itemsCount / pagination.perPage) > 1">
                    <button 
                    :class="{active: pagination.currentPage == page}" 
                    v-for="page in Math.ceil((itemsCount / pagination.perPage))" 
                    :key="page" 
                    @click="pagination.currentPage = page; scrollToStart()"
                    >{{ page }}</button>
                </div>
            </div>
        </div>
    </section>
</template>

<script>
import SmoothScroll from "smooth-scroll";

import compact from "lodash-es/compact";
import uniqBy from "lodash-es/uniqBy";
import filter from "lodash-es/filter";
import map from "lodash-es/map";
import orderBy from "lodash-es/orderBy";

export default {
    props: ['items'],
    data() {
        return {
            items_: this.reorder(this.items || require('@js/samples').default.load('events')),
            itemsVisible: null,
            selectCity: null,
            eventType: null,
            itemsCount: 0,
            pagination: {
                perPage: 9,
                currentPage: 1
            }
        }
    },
    watch: {
        eventType: function (value) {
            if (value != 'offline') {
                this.selectCity = null;
            }
            this.getItemsFilter(value, this.selectCity);
        },
        selectCity: function(value) {
            this.getItemsFilter(this.eventType, value);
        }
    },
    methods: {
        reorder: function(items){
            return orderBy(items, [(item) => {return item.date_t && item.date_t != null}, 'date_t'], ['asc', 'asc']);
        },
        scrollToStart: () => {
            (new SmoothScroll()).animateScroll(document.querySelector('.section-events'));
        },
        getItemsFilter: function (type, city) {
            this.itemsVisible = this.items_;
            this.pagination.currentPage = 1;

            this.itemsVisible = type ? map(this.itemsVisible, function(item) {
                if (type === 'online') {
                    item.hidden = !item.type.online;
                } else if (type === 'offline') {
                    item.hidden = !item.type.offline;
                } else {
                    item.hidden = false;
                }
                return item;
            }) : this.items_;
            this.itemsVisible = filter(this.items_, function(e) { return !e.hidden; });
            
            this.itemsVisible = city ? map(this.itemsVisible, function(item) {
                if (city === item.city) {
                    item.hidden = false;
                } else if (city == 'null') {
                    item.hidden = false;
                } else {
                    item.hidden = true;
                }
                return item;
            }) : this.items_;

            this.itemsVisible = filter(this.itemsVisible, function(e) { return !e.hidden; });
            this.itemsCount = this.itemsVisible.length;
        }
    },
    mounted () {
        this.itemsCount = this.items_.length;
        this.itemsVisible = this.items_;
    },
    computed: {
        cities: function () {
            return compact(map(uniqBy(this.items_, 'city'), 'city'));
        },
    }
}
</script>